Subject: Re: [net-next Patch v2 4/5] octeontx2-pf: Add devlink support to configure TL1 RR_PRIO

From: Jakub Kicinski <[email-masked]>
Date: Mon, 23 Jan 2023 14:45:48 -0800

On Mon, 23 Jan 2023 22:05:58 +0200 Maxim Mikityanskiy wrote:
> OK, I seem to get it now, thanks for the explanation!
> 
> How do you set the priority for HTB, though? You mentioned this command
> to set priority of unclassified traffic:
> 
> devlink -p dev param set pci/0002:04:00.0 name tl1_rr_prio value 6 \
> cmode runtime
> 
> But what is the command to change priority for HTB?
> 
> What bothers me about using devlink to configure HTB priority is:
> 
> 1. Software HTB implementation doesn't have this functionality, and it
> always prioritizes unclassified traffic. As far as I understand, the
> rule for tc stuff is that all features must have a reference
> implementation in software.
> 
> 2. Adding a flag (prefer unclassified vs prefer classified) to HTB
> itself may be not straightforward, because your devlink command has a
> second purpose of setting priorities between PFs/VFs, and it may
> conflict with the HTB flag.

If there is a two-stage hierarchy the lower level should be controlled
by devlink-rate, no?